/*
	BromScript - On Runtime Scripting Language.
    Copyright (C) 2012 - 2013  Alex Brouwer (Bromvlieg: http://brom.4o3.nl/)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BROMSCRIPT_TABLE_INCLUDED
#define BROMSCRIPT_TABLE_INCLUDED

#include "SIF.h"
#include "Instance.h"
#include "Variable.h"

namespace BromScript{
	class Table
	{
	public:
		static int GetCount();

		Table(Instance* bromscript);
		~Table();

		Instance* BromScript;
		void Set(Scratch::CString key, Variable* var);
		Variable* Get(Scratch::CString key);
		Variable* GetByIndex(int index);
		Scratch::CString GetKeyByIndex(int index);
		bool HasKey(Scratch::CString key);
		int GetNextIndex(int spos);
		void Defrag();
		int Count;
		
		void Remove(Scratch::CString key);
		void Clear();
		
		Variable* operator[](Scratch::CString key);
	private:
		Scratch::CString** Keys;
		Variable** Values;
		int BufferSize;

		void AllocateMoreSpace();
	};
}

#endif